=== docs/sphinx/requirements.txt ===
sphinx_rtd_theme>=0.5.2
sphinxcontrib-napoleon>=0.7
