=== debian/changelog ===
obs-studio (28.0.1+dfsg1-3~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add minimum version of pipewire build-dep.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 04 Nov 2022 15:26:19 -0700

obs-studio (28.0.1+dfsg1-3) unstable; urgency=medium

  * debian/rules: Disable lua plugin on ppc64el

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 23 Sep 2022 23:25:15 +0200

obs-studio (28.0.1+dfsg1-2) unstable; urgency=medium

  * debian/patches: Refresh patch to drop ISA flags
  * debian/control: Breaks+Replaces obs-websocket (Closes: #1020498)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 23 Sep 2022 20:49:03 +0200

obs-studio (28.0.1+dfsg1-1) unstable; urgency=medium

  * Team upload.

  * New upstream version 28.0.1+dfsg1
    (Closes: #1017166)

  [ Sebastian Ramacher ]
  * New upstream version 28.0.0+dfsg1
    * Refresh patches
  * Remove cmake/bundle
  * Exclude mac plugins and a copy of AMF
  * Add BD on libffmpeg-nvenc-dev
  * Add BD on libxcb-composite0-dev
  * Disable browser check

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Refresh patches (again)
  * Additional networking related B-Ds
  * Drop the '+dfsg' from the VERSION_OVERRIDE
  * Set build options
    + Explicitly enable JACK
    + Explicitly disable sndio modules (Closes: #993458)
    + Disable AJA
  * Use reproducible build-date.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>
    (Closes: #975504)
  * Add another patch to make build reproducible
  * Add patch to fix spelling errors
  * Add patch to build obs-websocket against system libraries
  * Use 'target_compile_options()' to inject "-fvisibility=hidden"
  * Fix install paths to plugins
  * Install pipewire plugin
  * Make sure that PEM files are non-executable
  * Use d/clean to cleanup temporary files
  * Do not embed RPATH/RUNPATH into binaries
  * Update d/*.symbols
  * Update description of obs-plugins (Closes: #993600)
  * d/watch
    - Switch to new github location
    - Import Multi-Upstream-Tarballs
  * Add verbatim copy of Nayuki's Qr-Code-Generator
  * Add salsa-ci configuration
  * Apply 'wrap-and-sort -ast'
  * Update d/copyright
    * Drop superfluous file-patterns
    * Add 'licensecheck' target
    * Generate d/copyright_hints
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 20 Sep 2022 23:44:10 +0200

obs-studio (27.2.4+dfsg1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Sebastian Ramacher ]
  * debian/control: Disable luajit on ppc64el (Closes: #1011304)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 21 May 2022 17:27:16 +0200
